/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the ViewRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ViewRequest{}

// ViewRequest struct for ViewRequest
type ViewRequest struct {
	Source   *string `json:"source,omitempty"`
	Strategy *string `json:"strategy,omitempty"`
	//
	Columns []string `json:"columns,omitempty"`
}

// NewViewRequest instantiates a new ViewRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewViewRequest() *ViewRequest {
	this := ViewRequest{}
	return &this
}

// NewViewRequestWithDefaults instantiates a new ViewRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewViewRequestWithDefaults() *ViewRequest {
	this := ViewRequest{}
	return &this
}

// GetSource returns the Source field value if set, zero value otherwise.
func (o *ViewRequest) GetSource() string {
	if o == nil || IsNil(o.Source) {
		var ret string
		return ret
	}
	return *o.Source
}

// GetSourceOk returns a tuple with the Source field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ViewRequest) GetSourceOk() (*string, bool) {
	if o == nil || IsNil(o.Source) {
		return nil, false
	}
	return o.Source, true
}

// HasSource returns a boolean if a field has been set.
func (o *ViewRequest) HasSource() bool {
	if o != nil && !IsNil(o.Source) {
		return true
	}

	return false
}

// SetSource gets a reference to the given string and assigns it to the Source field.
func (o *ViewRequest) SetSource(v string) {
	o.Source = &v
}

// GetStrategy returns the Strategy field value if set, zero value otherwise.
func (o *ViewRequest) GetStrategy() string {
	if o == nil || IsNil(o.Strategy) {
		var ret string
		return ret
	}
	return *o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ViewRequest) GetStrategyOk() (*string, bool) {
	if o == nil || IsNil(o.Strategy) {
		return nil, false
	}
	return o.Strategy, true
}

// HasStrategy returns a boolean if a field has been set.
func (o *ViewRequest) HasStrategy() bool {
	if o != nil && !IsNil(o.Strategy) {
		return true
	}

	return false
}

// SetStrategy gets a reference to the given string and assigns it to the Strategy field.
func (o *ViewRequest) SetStrategy(v string) {
	o.Strategy = &v
}

// GetColumns returns the Columns field value if set, zero value otherwise.
func (o *ViewRequest) GetColumns() []string {
	if o == nil || IsNil(o.Columns) {
		var ret []string
		return ret
	}
	return o.Columns
}

// GetColumnsOk returns a tuple with the Columns field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ViewRequest) GetColumnsOk() ([]string, bool) {
	if o == nil || IsNil(o.Columns) {
		return nil, false
	}
	return o.Columns, true
}

// HasColumns returns a boolean if a field has been set.
func (o *ViewRequest) HasColumns() bool {
	if o != nil && !IsNil(o.Columns) {
		return true
	}

	return false
}

// SetColumns gets a reference to the given []string and assigns it to the Columns field.
func (o *ViewRequest) SetColumns(v []string) {
	o.Columns = v
}

func (o ViewRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ViewRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Source) {
		toSerialize["source"] = o.Source
	}
	if !IsNil(o.Strategy) {
		toSerialize["strategy"] = o.Strategy
	}
	if !IsNil(o.Columns) {
		toSerialize["columns"] = o.Columns
	}
	return toSerialize, nil
}

type NullableViewRequest struct {
	value *ViewRequest
	isSet bool
}

func (v NullableViewRequest) Get() *ViewRequest {
	return v.value
}

func (v *NullableViewRequest) Set(val *ViewRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableViewRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableViewRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableViewRequest(val *ViewRequest) *NullableViewRequest {
	return &NullableViewRequest{value: val, isSet: true}
}

func (v NullableViewRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableViewRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
